/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.DiagramaAutobusDAO;
import com.rjconsultores.ventaboletos.entidad.DetDiagramaAutobus;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import com.rjconsultores.ventaboletos.service.DiagramaAutobusService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Administrador
 */
@Service("diagramaAutobusService")
public class DiagramaAutobusServiceImpl implements DiagramaAutobusService {

    @Autowired
    private DiagramaAutobusDAO diagramaAutobusDAO;

    public List<DiagramaAutobus> obtenerTodos() {
        return diagramaAutobusDAO.obtenerTodos();
    }

    public DiagramaAutobus obtenerID(Short id) {
        return diagramaAutobusDAO.obtenerID(id);
    }

    @Transactional
    public DiagramaAutobus suscribir(DiagramaAutobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return diagramaAutobusDAO.suscribir(entidad);
    }

    @Transactional
    public DiagramaAutobus actualizacion(DiagramaAutobus entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return diagramaAutobusDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(DiagramaAutobus entidad) {

        for (DetDiagramaAutobus dda : entidad.getDetDiagramaAutobusList()) {
            dda.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            dda.setFecmodif(Calendar.getInstance().getTime());
            dda.setActivo(Boolean.FALSE);
        }

        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        diagramaAutobusDAO.actualizacion(entidad);
    }

    public List<DiagramaAutobus> buscar(String descDiagrama, Short maxparados,Short cantasientos) {
        return diagramaAutobusDAO.buscar(descDiagrama, maxparados, cantasientos);
    }

    public List<DiagramaAutobus> buscar(String descDiagrama) {
        return diagramaAutobusDAO.buscar(descDiagrama);
    }
}
